searchData={"items":[{"type":"module","title":"Islands.Coord","doc":"A coordinates struct and functions for the _Game of Islands_.\n\nThe coordinates struct contains the fields `row` and `col` representing the\ncoordinates of a square in the _Game of Islands_.\n\n###","ref":"Islands.Coord.html"},{"type":"module","title":"Based on the book [Functional Web Development](https://pragprog.com/titles/lhelph/functional-web-development-with-elixir-otp-and-phoenix/) by Lance Halvorsen. - Islands.Coord","doc":"","ref":"Islands.Coord.html#module-based-on-the-book-functional-web-development-https-pragprog-com-titles-lhelph-functional-web-development-with-elixir-otp-and-phoenix-by-lance-halvorsen"},{"type":"function","title":"Islands.Coord.compare/2","doc":"Compares two coordinates structs based on their square numbers.","ref":"Islands.Coord.html#compare/2"},{"type":"function","title":"Examples - Islands.Coord.compare/2","doc":"iex> alias Islands.Coord\n    iex> Coord.compare(Coord.new!(4, 7), Coord.new!(5, 7))\n    :lt","ref":"Islands.Coord.html#compare/2-examples"},{"type":"function","title":"Islands.Coord.new/1","doc":"Returns `{:ok, coord}` or `{:error, reason}` if given an invalid `square`.","ref":"Islands.Coord.html#new/1"},{"type":"function","title":"Examples - Islands.Coord.new/1","doc":"iex> alias Islands.Coord\n    iex> Coord.new(99)\n    {:ok, %Coord{row: 10, col: 9}}","ref":"Islands.Coord.html#new/1-examples"},{"type":"function","title":"Islands.Coord.new/2","doc":"Returns `{:ok, coord}` or `{:error, reason}` if given an invalid `row` or\n`col`.","ref":"Islands.Coord.html#new/2"},{"type":"function","title":"Examples - Islands.Coord.new/2","doc":"iex> alias Islands.Coord\n    iex> Coord.new(10, 10)\n    {:ok, %Coord{col: 10, row: 10}}","ref":"Islands.Coord.html#new/2-examples"},{"type":"function","title":"Islands.Coord.new!/1","doc":"Returns a coordinates struct or raises if given an invalid `square`.","ref":"Islands.Coord.html#new!/1"},{"type":"function","title":"Examples - Islands.Coord.new!/1","doc":"iex> alias Islands.Coord\n    iex> Coord.new!(99)\n    %Coord{row: 10, col: 9}\n\n    iex> alias Islands.Coord\n    iex> Coord.new!(101)\n    ** (ArgumentError) cannot create coord, reason: :invalid_square_number","ref":"Islands.Coord.html#new!/1-examples"},{"type":"function","title":"Islands.Coord.new!/2","doc":"Returns a coordinates struct or raises if given an invalid `row` or `col`.","ref":"Islands.Coord.html#new!/2"},{"type":"function","title":"Examples - Islands.Coord.new!/2","doc":"iex> alias Islands.Coord\n    iex> Coord.new!(10, 10)\n    %Coord{row: 10, col: 10}\n\n    iex> alias Islands.Coord\n    iex> Coord.new!(0, 1)\n    ** (ArgumentError) cannot create coord, reason: :invalid_coordinates","ref":"Islands.Coord.html#new!/2-examples"},{"type":"function","title":"Islands.Coord.to_row_col/1","doc":"Returns \"   \" or `{:error, reason}` if given an invalid `coord`.","ref":"Islands.Coord.html#to_row_col/1"},{"type":"function","title":"Examples - Islands.Coord.to_row_col/1","doc":"iex> alias Islands.Coord\n    iex> {:ok, coord} = Coord.new(2, 9)\n    iex> Coord.to_row_col(coord)\n    \"2 9\"","ref":"Islands.Coord.html#to_row_col/1-examples"},{"type":"function","title":"Islands.Coord.to_square/1","doc":"Returns a square number or `{:error, reason}` if given an invalid `coord`.","ref":"Islands.Coord.html#to_square/1"},{"type":"function","title":"Examples - Islands.Coord.to_square/1","doc":"iex> alias Islands.Coord\n    iex> {:ok, coord} = Coord.new(2, 9)\n    iex> Coord.to_square(coord)\n    19","ref":"Islands.Coord.html#to_square/1-examples"},{"type":"type","title":"Islands.Coord.col/0","doc":"Column number","ref":"Islands.Coord.html#t:col/0"},{"type":"type","title":"Islands.Coord.row/0","doc":"Row number","ref":"Islands.Coord.html#t:row/0"},{"type":"type","title":"Islands.Coord.square/0","doc":"Square number: (row - 1) * 10 + col","ref":"Islands.Coord.html#t:square/0"},{"type":"type","title":"Islands.Coord.t/0","doc":"A coordinates struct for the Game of Islands","ref":"Islands.Coord.html#t:t/0"}],"content_type":"text/markdown"}